﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTabControl;
using Infragistics.Win;
using System.Diagnostics;

namespace UltraTabControlWithTabGroups
{
    public partial class Form1 : Form
    {
        private UltraTab CurrentActiveTab;
        private UltraTabControl CurrentActiveTabControl;
        private UltraTabControl NewActiveTabControl;
        static Point pnt;
        static int InitialX;
        public Form1()
        {
            InitializeComponent();
            InitialX = ultraTabControl1.Location.X;
        }


        private void InitializeNewGroup()
        {
            UltraTabControl tabControl = new UltraTabControl();
            tabControl = new UltraTabControl();
            tabControl.AllowTabMoving = true;
            tabControl.ContextMenuStrip = this.contextMenuStrip1;
            tabControl.Size = new System.Drawing.Size(CurrentActiveTabControl.Size.Width / 2, CurrentActiveTabControl.Size.Height);
            CurrentActiveTabControl.Size = new System.Drawing.Size(CurrentActiveTabControl.Size.Width / 2, CurrentActiveTabControl.Size.Height);
            tabControl.Location = new Point(CurrentActiveTabControl.Location.X + (CurrentActiveTabControl.Size.Width), CurrentActiveTabControl.Location.Y);
            tabControl.Parent = this;
            tabControl.BringToFront();
            tabControl.MouseDown += new MouseEventHandler(ultraTabControl1_MouseDown);
            tabControl.MouseUp += new MouseEventHandler(ultraTabControl1_MouseUp);
            NewActiveTabControl = tabControl;
            MoveTab();
        }

        private void MoveTab()
        {
            CurrentActiveTabControl.Tabs.Remove(CurrentActiveTab);
            if (CurrentActiveTabControl.Tabs.Count == 0) 
            {
                NewActiveTabControl.Size = new Size(NewActiveTabControl.Width * 2, NewActiveTabControl.Height);
                NewActiveTabControl.Location = new Point(InitialX, NewActiveTabControl.Location.Y);
                this.Controls.Remove(CurrentActiveTabControl);
            }

            NewActiveTabControl.Tabs.Add(CurrentActiveTab);
            NewActiveTabControl.Controls.Add(CurrentActiveTab.TabPage);
            CurrentActiveTab.Selected = true;
        }


        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            CurrentActiveTabControl = ((UltraTabControl)this.ActiveControl);
            CurrentActiveTab = ((UltraTabControl)this.ActiveControl).ActiveTab;
            InitializeNewGroup();
        }


        private void ultraTabControl1_MouseDown(object sender, MouseEventArgs e)
        {
            pnt = e.Location;
            CurrentActiveTabControl = ((UltraTabControl)this.ActiveControl);
            CurrentActiveTab = ((UltraTabControl)this.ActiveControl).ActiveTab;
        }

        private void ultraTabControl1_MouseUp(object sender, MouseEventArgs e)
        {
            NewActiveTabControl = this.GetChildAtPoint(new Point(Cursor.Position.X - this.Location.X, Cursor.Position.Y - this.Location.Y)) as UltraTabControl;
            if (NewActiveTabControl != null && pnt != e.Location)
            {
                MoveTab();
            }
        }
    }
}
